//
//  M3XNote+CoreDataProperties.m
//  microMemex
//
//  Created by narita on 2017/05/11.
//  Copyright © 2017年 narita. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "M3XNote+CoreDataProperties.h"

@implementation M3XNote (CoreDataProperties)

#pragma mark - class methods

+ (NSFetchRequest<M3XNote *> *)fetchRequest 
{
	return [[NSFetchRequest alloc] initWithEntityName:@"M3XNote"];
}

+ (NSFetchRequest<M3XNote *> *)rootFetchRequest 
{
    NSFetchRequest<M3XNote*>* theFetchRequest = [M3XNote fetchRequest];
    theFetchRequest.predicate = [NSPredicate predicateWithFormat:@"isHome == YES"];

    return theFetchRequest;
}

#pragma mark - init methods

#pragma mark - dealloc

#pragma mark - NSCopying, hash, isEqual:

#pragma mark - NSCoding methods

#pragma mark - restorableState methods

#pragma mark - life cycle methods

#pragma mark - action methods

#pragma mark - event handling methods

#pragma mark - drawing methods

#pragma mark - delegate/datasource methods

#pragma mark - accessor methods (in pairs)

@dynamic memo;
@dynamic links;
@dynamic isHome;

- (NSString*) titleString
{    
    NSAttributedString* theAttributedString = [[NSAttributedString alloc] initWithRTFD:self.memo documentAttributes:nil];
    
    theAttributedString = [theAttributedString attributedSubstringFromRange:NSMakeRange(0, MIN(128, theAttributedString.length))];
    
    return theAttributedString.string;
}

- (NSArray<M3XNote*>*) sortedLinks
{
    NSSortDescriptor* theSortDescriptor = 
    [NSSortDescriptor sortDescriptorWithKey:@"titleString"
                                  ascending:YES];
    
    // ルートは除外する
    NSArray* theResult = [[self.links sortedArrayUsingDescriptors:@[theSortDescriptor]] 
                          filteredArrayUsingPredicate:[NSPredicate predicateWithFormat:@"isHome != YES"]];

    return theResult;
}

#pragma mark - Utility methods

@end
